/*
Автор Yuhan 
Сайт https://моделка.рф
Дата  03/03/2021
*/

#include <Wire.h>                                        
#include "U8glib.h"
U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE|U8G_I2C_OPT_DEV_0);                           
float input_volt = 0.0;
float temp=0.0;
float r1=100000.0; //сопротивление резистора r1
float r2=10090.0; // сопротивление резистора r2
#define DS_PIN 5  // пин 18b20

                                                              
void setup(){
 dallas_requestTemp(DS_PIN); // запрос 
  
  // delay (2000);
                

}                                                            
                                                             
void loop(){  
dallas_requestTemp(DS_PIN); // запрос
  delay(1000);
  //int value = dallas_getTemp(DS_PIN);


int analogvalue = analogRead(A1);
temp = (analogvalue * 5.0) / 1024.0; // формула для конвертирования значения напряжения
input_volt = temp / (r2/(r1+r2));
if (input_volt < 0.1)
{
input_volt=0.0;
}




u8g.firstPage();  
  do {
    draw();
  } while( u8g.nextPage() );                                                

}

void draw(void) {
int t=dallas_getTemp(DS_PIN);
  
if (t<-9){
  u8g.setFont(u8g_font_fur14r);
  //gdr14
  u8g.setPrintPos(0, 15);
u8g.print("OUT");
u8g.setPrintPos(75, 15);
 u8g.print(t);
 u8g.setPrintPos(115, 15);
    u8g.drawCircle(115, 3, 3);
                                                           
    }
    else
    {
    u8g.setFont(u8g_font_fur14r);
    u8g.setPrintPos(0, 15);  
    u8g.print("OUT");
     u8g.setPrintPos(85, 15);
    u8g.print(t);
    u8g.setPrintPos(115, 15);
    u8g.drawCircle(115, 3, 3);
    } 
                   
   u8g.setPrintPos(0, 39);
   u8g.print("BAT"); 
   
   u8g.setPrintPos(65, 39);                                           
    u8g.print(input_volt, 1);
    
    u8g.setPrintPos(115, 39);
     u8g.print("v");
  
  if(input_volt<=12.00){
u8g.setPrintPos(0, 63);
    u8g.print("Battery dead!!");
}
if(input_volt>12.00 && input_volt<12.20 ){
u8g.setPrintPos(0, 63);
    u8g.print("Battery 50%");
}
if(input_volt>12.20 && input_volt<12.30 ){
u8g.setPrintPos(0, 63);
    u8g.print("Battery 60%");
}
if(input_volt>12.30 && input_volt<12.40 ){
u8g.setPrintPos(0, 63);
    u8g.print("Battery 70%");
}
if(input_volt>12.40 && input_volt<12.50 ){
u8g.setPrintPos(0, 63);
    u8g.print("Battery 80%");
}
if(input_volt>12.50 && input_volt<13.00 ){
u8g.setPrintPos(0, 63);
    u8g.print("Battery OK");
}
  if(input_volt>=13.00){
   u8g.setPrintPos(0, 63);
    u8g.print("Nissan Serena"); 
  }
}


 // ======= dallas =======
void dallas_begin(uint8_t pin) {
  pinMode(pin, INPUT);
  digitalWrite(pin, LOW);
}
void dallas_requestTemp(uint8_t pin) {
  if (oneWire_reset(pin)) return;
  oneWire_write(0xCC, pin);
  oneWire_write(0x44, pin);
}
int dallas_getTemp(uint8_t pin) {
  uint8_t data[2];
  if (oneWire_reset(pin)) return;
  oneWire_write(0xCC, pin);
  oneWire_write(0xBE, pin);
  data[0] = oneWire_read(pin);
  data[1] = oneWire_read(pin);
  int result = (int)((data[1] << 8) | data[0]) * 0.0625; //>
  return result;
}
// ======= 1wire =======
boolean oneWire_reset(byte pin) {
  pinMode(pin, 1);
  delayMicroseconds(640);
  pinMode(pin, 0);
  delayMicroseconds(2);
  for (uint8_t c = 80; c; c--) {
    if (!digitalRead(pin)) {
      uint32_t tmr = micros();
      while (!digitalRead(pin)) {
        if (micros() - tmr > 200) return false;
      }
      return false;
    }
    delayMicroseconds(1);
  }
  return true;
}
void oneWire_write(uint8_t data, byte pin) {
  for (uint8_t p = 8; p; p--) {
    pinMode(pin, 1);
    if (data & 1) {
      delayMicroseconds(5);
      pinMode(pin, 0);
      delayMicroseconds(90);
    } else {
      delayMicroseconds(90);
      pinMode(pin, 0);
      delayMicroseconds(5);
    }
    data >>= 1;
  }
}
uint8_t oneWire_read(byte pin) {
  uint8_t data = 0;
  for (uint8_t p = 8; p; p--) {
    data >>= 1;
    pinMode(pin, 1);
    delayMicroseconds(2);
    pinMode(pin, 0);
    delayMicroseconds(8);
    bool dataBit = digitalRead(pin);
    delayMicroseconds(80);
    if (dataBit) data |= 0x80;
  }
  return data;                                                            
}
